<?php
// Own namespace
namespace Org\Mxchange\CoreFramework\User\Auth;

// Import framework stuff
use Org\Mxchange\CoreFramework\Filter\Filterable;
use Org\Mxchange\CoreFramework\Generic\FrameworkException;

/**
 * An exception thrown when authorization of the user has failed
 *
 * @author		Roland Haeder <webmaster@shipsimu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009 - 2021 Core Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.shipsimu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
class UserAuthorizationException extends FrameworkException {
	/**
	 * The super constructor for all exceptions
	 *
	 * @param	$filterInstance		An instance of the filter throwing this exception
	 * @param	$code				Error code
	 * @return	void
	 */
	public function __construct (Filterable $filterInstance, int $code) {
		// Construct the message
		$message = sprintf('[%s:%d] Authorization has failed. Error code %s',
			$filterInstance->__toString(),
			$this->getLine(),
			$this->getHexCode($code)
		);

		// Call parent exception constructor
		parent::__construct($message, $code);
	}

}
