<?php
// Own namespace
namespace Org\Mxchange\CoreFramework\Index;

// Import framework stuff
use Org\Mxchange\CoreFramework\Generic\FrameworkInterface;

/**
 * An interface for Indexable classes
 *
 * @author		Roland Haeder <webmaster@ship-simu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009 - 2021 Core Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.ship-simu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
interface Indexable extends FrameworkInterface {
	/**
	 * Magic for this index
	 */
	const INDEX_MAGIC = 'INDEXv0.1';

	/**
	 * Separator group->hash
	 */
	const SEPARATOR_GROUP_HASH = 0x01;

	/**
	 * Separator hash->gap position
	 */
	const SEPARATOR_HASH_GAP_POSITION = 0x02;

	/**
	 * Separator gap position->length
	 */
	const SEPARATOR_GAP_LENGTH = 0x03;

	/**
	 * Checks whether the index has been fully loaded (and parsed)
	 *
	 * @return	$isLoaded	Whether the index has been loaded
	 */
	function isIndexLoaded ();

}
